Subject: Re: [ovs-dev] selftests: openvswitch: Questions about possible enhancements

From: Simon Horman <[email-masked]>
Date: Fri, 26 Apr 2024 08:05:24 +0100

On Thu, Apr 25, 2024 at 12:21:51PM -0700, Jakub Kicinski wrote:
> On Thu, 25 Apr 2024 19:57:19 +0100 Simon Horman wrote:
> > openvswitch.sh does not appear to have any dependencies on Open vSwitch
> > user-space. My understanding is that, rather, it makes use of
> > tools/testing/selftests/net/openvswitch/ovs-dpctl.py to talk to the Kernel
> > using Netlink (which is also what Open vSwitch user-space does).
> > 
> > My brief testing indicates that for this the only dependencies
> > when running on Amazon Linux 2 are python3 and pyroute2.
> > 
> > I think that it should be possible to port pmtu.sh to use ovs-dpctl.py.
> > This would require some enhancements to ovs-dpctl.py to handle adding the
> > tunnel vports (interfaces).
> > 
> > As an aside, to run the Open vSwitch tests in pmtu.sh the openvswitch
> > kernel module is needed. So I think it would make sense to add
> > CONFIG_OPENVSWITCH to tools/testing/selftests/net/config.
> > 
> > That would mean that tools/testing/selftests/net/config also has all
> > the requirements to run openvswitch.sh. If so, we probably wouldn't need to
> > add tools/testing/selftests/net/openvswitch/config or otherwise do anything
> > special to configure the kernel for openvswitch.sh.
> 
> That sounds great, for simplicity we could move the ovs files down 
> to the .../net/ directory. It'd be cool to not have to do that, and
> let us separate tests more clearly into directories. But right now
> every directory has its own runner so there's a high price to pay
> for a primarily aesthetic gain :(

Understood. Let's work on getting the Open vSwitch portions of pmtu.sh, and
openvswitch.sh into a little bit better shape. Then we can consider moving
the contents of tools/.../net/openvswitch/. It would certainly be nice to
have the Open vSwitch tests run automatically.